function [position,isterminal,direction]=detect_per(t,s,params)
%purpose: foot strike event function for the ode solver

%written by Jian Jin
% Copyright (c) 2022 Jian Jin
% Permission is hereby granted, free of charge, to any person obtaining a copy
% of this software and associated documentation files (the "Software"), to deal
% in the Software without restriction, including without limitation the rights
% to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
% copies of the Software, and to permit persons to whom the Software is
% furnished to do so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

delta_h=params.delta_h;
%vertical position of the toe of the swing leg is zero, with constraint: absolute stance angle not too small
position(1)=cos(s(1))-cos(s(2)-s(1))-delta_h+(t>0)-1+(s(1)<-0.05)-1; %foot strike event
isterminal(1)=1; %1 means terminal  %0 keeps running but only record event time
direction(1)=-1; %-1,0,1

position(2)=s(1)-pi/2;%falling event
isterminal(2)=1; 
direction(2)=0;  

position(3)=s(1)+pi/2;%falling event
isterminal(3)=1; 
direction(3)=0;  

position(4)=s(1)-pi;%falling event
isterminal(4)=1; 
direction(4)=0;  

position(5)=s(1)-2*pi;%falling event
isterminal(5)=1; 
direction(5)=0;  

