function [J] = jacob_reduced(s,params)
%purpose: calculate reduced Jacobian matrix (in Hamiltonian form) 
%see reference: Revisiting the stability of 2D passive biped walking: Local behavior

%written by Jian Jin
% Copyright (c) 2022 Jian Jin
% Permission is hereby granted, free of charge, to any person obtaining a copy
% of this software and associated documentation files (the "Software"), to deal
% in the Software without restriction, including without limitation the rights
% to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
% copies of the Software, and to permit persons to whom the Software is
% furnished to do so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

params.delta_h=0;
pert_size=1e-8;
pert=pert_size*eye(4);

[t0,s0]=run_simulation_per(s,params,[0 5]);
s0_output=s0(end,:);

Pert_Coor = [1/sqrt(5) 2/sqrt(5) 0 0;0 0 1 0]; % perturbation coordinates
delta_Sigma=[1 0;0 1]*pert_size;
Pert_Mat = [Pert_Coor'*delta_Sigma]';
s0_output=Pert_Coor*s0_output';

for i=1:2
    s0_a=s0(end,:);
    s0_a=Pert_Mat(i,:) + s0_a;    
    [t1,s1]=run_simulation_per(s0_a,params,[0 5]);
    s0_output_a=Pert_Coor*s1(end,:)';
    Jacobian(:,i)=(s0_output_a'-s0_output')/pert_size;
end

J=Jacobian;

