function [t1,s1,ie,te]=run_simulation_per(s0,params,timebase)
%purpose: step function in Hamiltonian form

%written by Jian Jin
% Copyright (c) 2022 Jian Jin
% Permission is hereby granted, free of charge, to any person obtaining a copy
% of this software and associated documentation files (the "Software"), to deal
% in the Software without restriction, including without limitation the rights
% to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
% copies of the Software, and to permit persons to whom the Software is
% furnished to do so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

odeopt = odeset('AbsTol',1e-8,'RelTol',1e-8,'maxstep',1e-3,'events',@detect_per);%'maxstep',1e-3
[t1,s1,te,~,ie]=ode45(@Walker_Forward,timebase,s0,odeopt,params);

s_end=s1(end,:);
if ie==1
    % inelastic collision
    s_collision1=pendulumcollision(s_end,params.beta);
    s_collision1=s_collision1';
else
    s_collision1=s_end';
end

%add heel strike state to time and state vectors
t1(end+1)=t1(end);
s1(end+1,:)=s_collision1;